#include <iostream>

using namespace std;

int main()
{
    int n, q;
    cin >> n;
    int niz[n];
    string resenja[n];

    for (int i = 0; i < n; i++) {
        cin >> niz[i];
    }

    cin >> q;
    for (int brPrimera = 0; brPrimera < q; brPrimera++) {
        int pocetak, kraj, izbrisan = n + 3, provera = 0;
        cin >> pocetak >> kraj;
        for (int i = pocetak - 1; i < kraj; i++) {
            if ((niz[i - 1] > niz[i] && i != (pocetak - 1)) || (niz[i + 1] < niz[i] && i != (kraj - 1))) {
                izbrisan = i;
                i = kraj;
            }
        }

        for (int i = pocetak - 1; i < kraj; i++) {
            if ((niz[i - 1] > niz[i] && i != (pocetak - 1) && i != izbrisan && i - 1 != izbrisan) || (niz[i + 1] < niz[i] && i != (kraj - 1) && i != izbrisan && i + 1 != izbrisan)) {
                provera = 1;
                resenja[brPrimera] = "NE";
                i = kraj;
            }
        }
        if (provera == 0) {
            resenja[brPrimera] = "DA";
        }
    }

    for (int i = 0; i < n; i++) {
        cout << resenja[i] << endl;
    }

    return 0;
}